package com.hfkj.dao;

import com.hfkj.entity.BsMerPlatformNo;
import com.hfkj.entity.BsMerPlatformNoExample.Criteria;
import com.hfkj.entity.BsMerPlatformNoExample.Criterion;
import com.hfkj.entity.BsMerPlatformNoExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsMerPlatformNoSqlProvider {

    public String countByExample(BsMerPlatformNoExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_mer_platform_no");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsMerPlatformNoExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_mer_platform_no");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsMerPlatformNo record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_mer_platform_no");
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.VALUES("platform_type", "#{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.VALUES("platform_no", "#{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.VALUES("cup_no", "#{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPosId() != null) {
            sql.VALUES("pos_id", "#{posId,jdbcType=VARCHAR}");
        }
        
        if (record.getBranchId() != null) {
            sql.VALUES("branch_id", "#{branchId,jdbcType=VARCHAR}");
        }
        
        if (record.getMerPublicKey() != null) {
            sql.VALUES("mer_public_key", "#{merPublicKey,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOperatorId() != null) {
            sql.VALUES("platform_operator_id", "#{platformOperatorId,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOperatorPwd() != null) {
            sql.VALUES("platform_operator_pwd", "#{platformOperatorPwd,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundCertUrl() != null) {
            sql.VALUES("refund_cert_url", "#{refundCertUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundCertPwd() != null) {
            sql.VALUES("refund_cert_pwd", "#{refundCertPwd,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsMerPlatformNoExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("company_id");
        sql.SELECT("agent_id");
        sql.SELECT("mer_id");
        sql.SELECT("mer_no");
        sql.SELECT("platform_type");
        sql.SELECT("platform_no");
        sql.SELECT("cup_no");
        sql.SELECT("pos_id");
        sql.SELECT("branch_id");
        sql.SELECT("mer_public_key");
        sql.SELECT("platform_operator_id");
        sql.SELECT("platform_operator_pwd");
        sql.SELECT("refund_cert_url");
        sql.SELECT("refund_cert_pwd");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_mer_platform_no");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsMerPlatformNo record = (BsMerPlatformNo) parameter.get("record");
        BsMerPlatformNoExample example = (BsMerPlatformNoExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_platform_no");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPosId() != null) {
            sql.SET("pos_id = #{record.posId,jdbcType=VARCHAR}");
        }
        
        if (record.getBranchId() != null) {
            sql.SET("branch_id = #{record.branchId,jdbcType=VARCHAR}");
        }
        
        if (record.getMerPublicKey() != null) {
            sql.SET("mer_public_key = #{record.merPublicKey,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOperatorId() != null) {
            sql.SET("platform_operator_id = #{record.platformOperatorId,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOperatorPwd() != null) {
            sql.SET("platform_operator_pwd = #{record.platformOperatorPwd,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundCertUrl() != null) {
            sql.SET("refund_cert_url = #{record.refundCertUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundCertPwd() != null) {
            sql.SET("refund_cert_pwd = #{record.refundCertPwd,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_platform_no");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        sql.SET("pos_id = #{record.posId,jdbcType=VARCHAR}");
        sql.SET("branch_id = #{record.branchId,jdbcType=VARCHAR}");
        sql.SET("mer_public_key = #{record.merPublicKey,jdbcType=VARCHAR}");
        sql.SET("platform_operator_id = #{record.platformOperatorId,jdbcType=VARCHAR}");
        sql.SET("platform_operator_pwd = #{record.platformOperatorPwd,jdbcType=VARCHAR}");
        sql.SET("refund_cert_url = #{record.refundCertUrl,jdbcType=VARCHAR}");
        sql.SET("refund_cert_pwd = #{record.refundCertPwd,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsMerPlatformNoExample example = (BsMerPlatformNoExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsMerPlatformNo record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_platform_no");
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPosId() != null) {
            sql.SET("pos_id = #{posId,jdbcType=VARCHAR}");
        }
        
        if (record.getBranchId() != null) {
            sql.SET("branch_id = #{branchId,jdbcType=VARCHAR}");
        }
        
        if (record.getMerPublicKey() != null) {
            sql.SET("mer_public_key = #{merPublicKey,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOperatorId() != null) {
            sql.SET("platform_operator_id = #{platformOperatorId,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOperatorPwd() != null) {
            sql.SET("platform_operator_pwd = #{platformOperatorPwd,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundCertUrl() != null) {
            sql.SET("refund_cert_url = #{refundCertUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundCertPwd() != null) {
            sql.SET("refund_cert_pwd = #{refundCertPwd,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsMerPlatformNoExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}